<?php

define('EQDKP_INC', true);
$eqdkp_root_path = './';
include_once($eqdkp_root_path . 'common.php');
$user->check_auth('u_member_list');

require('library.mysql.php');

require('config.php');

/* test data

Test Data:
BlackWing Lair/n06/15/06 19:38:10/nMorpher/nRazorgore/n8/n/pMorpher/nPaladin/nStaladar/nMage/n/p/r
Molten Core/n06/15/06 19:38:10/nMorpher/nRagnaros/n8/n/pMorpher/nPaladin/nStaladar/nMage/nThellanorn/nMage/n/p/r

Test Data of two mobs in list:
BlackWing Lair/n06/15/06 19:38:10/nMorly/nRazorgore/n8/n/pMorly/nPriest/n/p/rBlackWing Lair/n06/15/06 19:38:10/nMorly/nBroodlord/n8/n/pMorly/nPriest/n/p/r


Test Data with an item involved:
BlackWing Lair/n06/15/06 19:38:10/nMorpher/nRazorgore/n8/n/pMorpher/nPaladin/nStaladar/nMage/n/p/r


Item Test Data:
Outdoor World Bosses/n06/19/06 22:02:24/nMorly/nDeath Test/n1/n/pMorly/nPriest/n/iBindings of Transcendence/i225/i/n/p/r

Item Test Data with player getting two items from one boss:
Outdoor World Bosses/n06/19/06 22:02:24/nMorly/nDeath Test/n1/n/pMorly/nPriest/n/iBindings of Transcendence/i225/iGloves of Rapid Evolution/i100/i/n/p/r

Gloves of Rapid Evolution
Snapshot data:
Outdoor World Bosses/n06/15/06 22:02:24/nMorly/nSnapshot Death/n0/n/pMorly/nPriest/n/p/r

Item Test Data with one adjustment:
Outdoor World Bosses/n06/19/06 22:02:24/nMorly/nDeath Test/n300/n/pMorly/nPriest/n/iBindings of Transcendence/i225/i/n/p/r/aMorly/aReason is because priests are special/a06/19/06 23:02:24/a10/a

New Data Test:
Molten Core/n06/19/06 22:02:24/nMorly/nDeath Test/n1/n/pMorly/nPriest/n/iBindings of Transcendence/i225/i/nMorpher/nPaladin/n/i/i/i/n/p/r

Debug Data:

Molten Core/n06/19/06 22:02:24/nMorly/nDeath Test/n1/n/pMorly/nPriest/n/iBindings of Transcendence/i225/i/nMorpher/nPaladin/n/i/i/i/n/p/r
Yields:
Passed!

Molten Core/n06/19/06 22:02:24/nMorly/nDeath Test/n1/n/pMorly/nPriest/n/i/i/i/nMorpher/nPaladin/n/i/i/i/n/p/r
Yields:


*/

sqlConnect($dbuser, $dbpass, $dbhost);

sqlSetDatabase($dbname);

checkdb($table_prefix);

    $players = sqlSelectMany("{$table_prefix}members");

    $rows = sqlSelectMany("{$table_prefix}classes");

    $classes = array();

    foreach ($rows as $row) $classes[$row['class_id']] = $row['class_name'];

	foreach ($players as $player)

	{

        $data .= $player['member_name'].'\n';

		$earned = $player['member_earned'];

		$spent = $player['member_spent'];

		$adjustment = $player['member_adjustment'];

		$currentdkp = $earned - $spent - $adjustment;

		$data .= $currentdkp.'\n';

		$data .= $classes[$player['member_class_id']].'\n';
		
    }
?>



<html>

<head><title>Export EQdkp Data to DKP Manager</title></head>

<p><a href="http://<Your URL>/listmembers.php"> Back to Standings</a></p>

<body style="font-family: Arial; font-size: 12px; background-color: #FDFDFD; color: #101030; padding-left: 50px; padding-top: 50px;">

<style>

td { font-size: 12px; }

</style>



Select all the data in the textbox below and copy it (Ctrl+C).

Open the Import window in World of Warcraft using /dkpm import.

Paste the data into the textbox (this will freeze WoW for 1 minute).



<br>

<br>



<form method="post">

<br>

<br>





<textarea style="width: 700px; height: 400px;" name="data" onClick="select();"><?php echo $data ?></textarea>

<br>

<br>



<input type="submit" value="Retrieve EQdkp Data">



</form>





</body>

</html>



