<?php

/* test data

BlackWing Lair/n

06/15/06 19:38:10/n

Morpher/n

Razorgore/n

8/n/pMorpher/n

Paladin/n

Staladar/n

Mage/n/p/r







*/

define('EQDKP_INC', true);
//define('IN_ADMIN', true);
//$eqdkp_root_path = './../';
$eqdkp_root_path = './';
include_once($eqdkp_root_path . 'common.php');
//$user->check_auth('a_', true);
//$user->check_auth('u_member_list');

require('library.mysql.php');



require('config.php');







sqlConnect($dbuser, $dbpass, $dbhost);



sqlSetDatabase($dbname);



checkdb($table_prefix);







?>







<html>



<head><title>Import DragonLord's DKP Data into EQdkp</title></head>

<p><a href="<Your URL>/listmembers.php"> Back to Standings</a></p>

<body style="font-family: Arial; font-size: 12px; background-color: #FDFDFD; color: #101030; padding-left: 50px; padding-top: 50px;">







<?php





$data = $_POST['data'];







$members = array();

$rows = sqlSelectMany($table_prefix.'members');

foreach ($rows as $row) $members[$row['member_name']] = $row;



$classes = array();

$rows = sqlSelectMany($table_prefix.'classes');

foreach ($rows as $row) $classes[$row['class_name']] = $row['class_id'];



$events = array();

$rows = sqlSelectMany($table_prefix.'events');

foreach ($rows as $row) $events[$row['event_name']] = $row;



/* test data

Test Data:
BlackWing Lair/n06/15/06 19:38:10/nMorpher/nRazorgore/n8/n/pMorpher/nPaladin/nStaladar/nMage/n/p/r
Molten Core/n06/15/06 19:38:10/nMorpher/nRagnaros/n8/n/pMorpher/nPaladin/nStaladar/nMage/nThellanorn/n/Mage/n/p/r

Test Data of two mobs in list:
BlackWing Lair/n06/15/06 19:38:10/nMorly/nRazorgore/n8/n/pMorly/nPriest/n/p/rBlackWing Lair/n06/15/06 19:38:10/nMorly/nBroodlord/n8/n/pMorly/nPriest/n/p/r


Test Data with an item involved:
BlackWing Lair/n06/15/06 19:38:10/nMorpher/nRazorgore/n8/n/pMorpher/nPaladin/nStaladar/nMage/n/p/r


Item Test Data:
Outdoor World Bosses/n06/19/06 22:02:24/nMorly/nDeath Test/n1/n/pMorly/nPriest/n/iBindings of Transcendence/i225/i/n/p/r

Item Test Data with player getting two items from one boss:
Outdoor World Bosses/n06/19/06 22:02:24/nMorly/nDeath Test/n1/n/pMorly/nPriest/n/iBindings of Transcendence/i225/iGloves of Rapid Evolution/i100/i/n/p/r

Gloves of Rapid Evolution
Snapshot data:
Outdoor World Bosses/n06/15/06 22:02:24/nMorly/nSnapshot Death/n0/n/pMorly/nPriest/n/p/r

Item Test Data with one adjustment:
Outdoor World Bosses/n06/19/06 22:02:24/nMorly/nDeath Test/n300/n/pMorly/nPriest/n/iBindings of Transcendence/i225/i/n/p/r/aMorly/aReason is because priests are special/a06/19/06 23:02:24/a10/a


Debug Data:
INSERT INTO eqdkp_raids (raid_name,raid_date,raid_note,raid_value,raid_added_by,event_id) VALUES ('Molten Core',1150414690,'Ragnaros',8,'DragonLords DKP (by Morpher)',)
INSERT INTO eqdkp_raid_attendees (raid_id,member_name,member_id) VALUES (2,'Morpher',)
*/



if ($data) 

{

	$adjustments = explode("/a", $data);
	
	$data = explode("/r", $data);
	
		
	for ($i = 0; $i < (sizeof($data) - 1); $i++) 

	{

		$rest = explode("/p", $data[$i]);

		$event = explode("/n", $rest[0]);

		$players = explode("/n", $rest[1]);

		$location= $event[0];

		$raiddate = $event[1];

		$raiddate = ConvertTimestringToTimestamp($raiddate);

		$playername = $event[2];

		$boss = $event[3];

		$bossdkp = $event[4];

		//echo 'sizeof($data): '.sizeof($data).'<br>';

		//echo 'inserting raid: '.$location.'<br>';

		$rid = sqlInsert($table_prefix.'raids', array(

			'raid_name' => "'".addslashes($location)."'",

			'raid_date' => $raiddate,

			'raid_note' => "'".addslashes($boss)."'",

			'raid_value' => $bossdkp,

			'raid_added_by' => "'DragonLords DKP (by ".$playername.")'",

			'event_id' => $events[$location]['event_id'],

		));

		

        // raid added log.

		$log_action = array(

			'header' => '{L_ACTION_RAID_ADDED}',

			'id'            => $rid,

			'{L_EVENT}'     => $location,

			'{L_ATTENDEES}' => trim(implode(', ', $players), ', '),

			'{L_NOTE}'      => "'".addslashes($boss)."'",

			'{L_VALUE}'     => $bossdkp,

			'{L_ADDED_BY}'  => 'DragonLords DKP (by '.$playername.')',

		);

						

		sqlInsert($table_prefix.'logs', array(

			'log_date' => time(),

			'log_type' => "'{L_ACTION_RAID_ADDED}'",

			'log_action' => "'".addslashes(make_log_action($log_action))."'",

			'log_ipaddress' => "'{$_SERVER['REMOTE_ADDR']}'",

			'log_sid' => "0",

			'log_result' => "'{L_SUCCESS}'",

			'admin_id' => 0,

		));



		for ($j = 0; $j <= (sizeof($players) - 3); $j = $j + 3) 

		{ //loop through the player names of the raid/boss event.

			echo 'found player: '.$players[$j].'<br>';

			//echo 'j: '.$j.'<br>';

			if (!$members[$players[$j]]) 

			{ //here if member is not found.

				//echo 'inserting player: '.$players[$j].'<br>';

				//exit;

				// member added log.

				$log_action = array(

					'header'         => '{L_ACTION_MEMBER_ADDED}',

					'{L_NAME}'       => $players[$j],

					'{L_EARNED}'     => 0,

					'{L_SPENT}'      => 0,

					'{L_ADJUSTMENT}' => 0,

					'{L_LEVEL}'      => 0,

					'{L_RACE}'       => "''",

					'{L_CLASS}'      => "''",

					'{L_ADDED_BY}'   => 'DragonsLords DKP (by '.$playername.')',

				);

							

				sqlInsert($table_prefix.'logs', array(

					'log_date' => time(),

					'log_type' => "'{L_ACTION_MEMBER_ADDED}'",

					'log_action' => "'".addslashes(make_log_action($log_action))."'",

					'log_ipaddress' => "'{$_SERVER['REMOTE_ADDR']}'",

					'log_sid' => "0",

					'log_result' => "'{L_SUCCESS}'",

					'admin_id' => 0,

				));

				

				$mid = sqlInsert($table_prefix.'members', array('member_name' => "'".addslashes($players[$j])."'", 'member_class_id' => $classes[trim($players[$j + 1])]));
				
				// need to requery members array
				$rows = sqlSelectMany($table_prefix.'members');

				foreach ($rows as $row) $members[$row['member_name']] = $row;

			}



			//echo 'inserting raid attendees: '.$location.'<br>';
			echo 'Member Name: '.$members[$players[$j]]['member_name'].'<br>';
			echo 'Member ID: '.$members[$players[$j]]['member_id'].'<br>';
			
			sqlInsert($table_prefix.'raid_attendees', array(

				'raid_id' => $rid,

				'member_name' => "'".addslashes($players[$j])."'",

				'member_id' => $members[$players[$j]]['member_id'],

			));

		  

			

			// member updated log.

			$log_action = array(

				'header'         			=> '{L_ACTION_MEMBER_UPDATED}',

				'{L_NAME_BEFORE}'  			=> $players[$j],

				'{L_EARNED_BEFORE}'     	=> $members[$players[$j]]['member_earned'],

				'{L_SPENT_BEFORE}'      	=> $members[$players[$j]]['member_spent'],

				'{L_ADJUSTMENT_BEFORE}' 	=> $members[$players[$j]]['member_adjustment'],

				'{L_LEVEL_BEFORE}'      	=> $members[$players[$j]]['member_level'],

				'{L_RACE_BEFORE}'       	=> "''",

				'{L_CLASS_BEFORE}'      	=> "''",

				'{L_NAME_AFTER}'     		=> $players[$j],

				'{L_EARNED_AFTER}'      	=> $members[$players[$j]]['member_earned'] + $bossdkp,

				'{L_SPENT_AFTER}' 			=> $members[$players[$j]]['member_spent'],

				'{L_ADJUSTMENT_AFTER}'      => $members[$players[$j]]['member_adjustment'],

				'{L_LEVEL_AFTER}'       	=> $members[$players[$j]]['member_level'],

				'{L_RACE_AFTER}'      		=> "''",

				'{L_CLASS_AFTER}'      		=> "''",

				'{L_ADDED_BY}'   			=> 'DragonLords DKP (by '.$playername.')',

			);

						

			sqlInsert($table_prefix.'logs', array(

				'log_date' => time(),

				'log_type' => "'{L_ACTION_MEMBER_UPDATED}'",

				'log_action' => "'".addslashes(make_log_action($log_action))."'",

				'log_ipaddress' => "'{$_SERVER['REMOTE_ADDR']}'",

				'log_sid' => "0",

				'log_result' => "'{L_SUCCESS}'",

				'admin_id' => 0,

			));

			

			//echo '(before) member name: '.$members[$players[$j]]['member_name'].'<br>';

			//echo '(before) member earned: '.$members[$players[$j]]['member_earned'].'<br>';

			//add items for players here
			
			//  Outdoor World Bosses/n06/19/06 22:02:24/nMorly/nDeath Test/n1/n/pMorly/nPriest/n/iBindings of Transcendence/i225/i/n/p/r
			//  Outdoor World Bosses/n06/19/06 22:02:24/nMorly/nDeath Test/n1/n/pMorly/nPriest/n/i/i/i/n/p/r
			
			$playeritems = explode("/i", $players[$j + 2]);
			//echo '/i item: '.$playeritems[1].'<br>';
			//echo '/i dkp: '.$playeritems[2].'<br>';
			
			for ($picnt = 1; $picnt <= (sizeof($playeritems) - 2); $picnt = $picnt + 2) 
			{
				if ($playeritems[$picnt] and $playeritems[$picnt + 1])
				{
					sqlInsert($table_prefix.'items', array(
		
						'item_name' => "'".addslashes($playeritems[$picnt])."'",
		
						'item_buyer' => "'".addslashes($players[$j])."'",
		
						'raid_id' => $rid,
		
						'item_value' => $playeritems[$picnt + 1],
		
						'item_date' => $raiddate,
		
						'item_added_by' => "'DragonLords DKP (by ".$playername.")'",
		
						//'item_group_key' => "'".gen_group_key($rest[2], $rest[1], $raid[6])."'",
		
					));
	
					$members[$players[$j]]['member_spent'] += $playeritems[$picnt + 1];
				}
			}



			$members[$players[$j]]['member_earned'] += $bossdkp;

			// prevent going over max dkp
			// Outdoor World Bosses/n07/9/06 10:02:24/nMorpher/nDeath Test/n2/n/pMorpher/nPaladin/n/i/i/i/n/p/rOutdoor World Bosses/n07/9/06 10:02:24/nMorpher/nDeath Test/n8/n/pMorpher/nPaladin/n/i/i/i/n/p/r
			
			//if(($members[$players[$j]]['member_earned'] - $members[$players[$j]]['member_spent']) > 500)
			//{
			//	$members[$players[$j]]['member_earned'] = $members[$players[$j]]['member_spent'] + 500;
			//}
			

			$members[$players[$j]]['member_lastraid'] = $raiddate;

			$members[$players[$j]]['member_raidcount'] += 1;

			if ($members[$players[$j]]['member_firstraid'] == 0) 
			{
				$members[$players[$j]]['member_firstraid'] = $raiddate;
			}

			//echo 'members dkp awarded: '.$players[$j].'<br>';

			//echo 'members dkp earned: '.$members[$players[$j]]['member_earned'].'<br>';

			

			

			// put in item added information here

			$data2 = array(

			  'member_earned' => $members[$players[$j]]['member_earned'] + 0,

			  'member_spent' => $members[$players[$j]]['member_spent'] + 0,

			  'member_adjustment' => $members[$players[$j]]['member_adjustment'] + 0,

			  'member_raidcount' => $members[$players[$j]]['member_raidcount'] + 0,

			  'member_lastraid' => $members[$players[$j]]['member_lastraid'] + 0,

			  'member_firstraid' => $members[$players[$j]]['member_firstraid'] + 0,

			);

			$mid = $members[$players[$j]]['member_id'];

			
			

			//echo '(after) member name: '.$members[$players[$j]]['member_name'].'<br>';

			//echo '(after) member earned: '.$members[$players[$j]]['member_earned'].'<br>';

			sqlUpdate($table_prefix.'members', $data2, "member_id = {$members[$players[$j]]['member_id']}");
			
		}
		
			
	}

	// *********************  here to add in adjustments at end of data string. ************************************************************************
		
	// Outdoor World Bosses/n06/19/06 22:02:24/nMorly/nDeath Test/n300/n/pMorly/nPriest/n/iBindings of Transcendence/i225/i/n/p/r/aMorly/aReason is because priests are special/a06/19/06 23:02:24/a10/a
	
	//echo '/a name: '.$adjustments[1].'<br>';
	//echo '/a reason: '.$adjustments[2].'<br>';
	//echo '/a date: '.$adjustments[3].'<br>';
	//echo '/a adjustment: '.$adjustments[4].'<br>';
		
	for ($adj = 1; $adj <= (sizeof($adjustments) - 2); $adj = $adj + 2) 
	{
		if ($adjustments[$adj] and $adjustments[$adj + 1] and $adjustments[$adj + 2] and $adjustments[$adj + 3])
		{
			sqlInsert($table_prefix.'adjustments', array(
			'adjustment_value' => $adjustments[$adj + 3],
			'adjustment_date' => ConvertTimestringToTimestamp($adjustments[$adj + 2]),
			'member_name' => "'".addslashes($adjustments[$adj])."'",
			'adjustment_reason' => "'".addslashes($adjustments[$adj + 1])."'",
			'adjustment_added_by' => "'DragonLords DKP (by ".$playername.")'",
			//'adjustment_group_key' => "'".gen_group_key($rest[3], $rest[2], $rest[1])."'"
			));
			
			$members[$adjustments[$adj]]['member_adjustment'] += $adjustments[$adj + 3];
		
			// prevent going over max dkp

			/*if(($members[$adjustments[$adj]]['member_earned'] - $members[$adjustments[$adj]]['member_spent'] + $members[$adjustments[$adj]]['member_adjustment']) > 500)
			{
				// 600 earned
				// 100 spent
				// +5 adjustment should yield 600 earned and 600 current.
				
				// 600 earned
				// 100 spent
				// -5 adjustment should yield 600 earned and 595 current
				$members[$adjustments[$adj]]['member_earned'] = $members[$adjustments[$adj]]['member_spent'] + (500 - $members[$adjustments[$adj]]['member_adjustment']);
			}
			*/
			
			$data3 = array(

			  'member_earned' => $members[$adjustments[$adj]]['member_earned'] + 0,

			  'member_spent' => $members[$adjustments[$adj]]['member_spent'] + 0,

			  'member_adjustment' => $members[$adjustments[$adj]]['member_adjustment'] + 0,

			  'member_raidcount' => $members[$adjustments[$adj]]['member_raidcount'] + 0,

			  'member_lastraid' => $members[$adjustments[$adj]]['member_lastraid'] + 0,

			  'member_firstraid' => $members[$adjustments[$adj]]['member_firstraid'] + 0,

			);

			$mid = $members[$adjustments[$adj]]['member_id'];
			
			sqlUpdate($table_prefix.'members', $data3, "member_id = {$members[$adjustments[$adj]]['member_id']}");
		}
	}
			
	echo "<b>Done!</b><br><br>Performed the following SQL queries:<br><br>";

	foreach ($GLOBALS['SqlQueries'] as $query) 

	{

		echo $query.'<br>';

    }

	exit;



}



function ConvertTimestringToTimestamp($timestring)

{

	$parts = preg_split('/[\/ :]/', $timestring);

	return mktime($parts[3], $parts[4], $parts[5], $parts[0], $parts[1], $parts[2]);

}



function make_log_action($action = array())

    {

        $str_action = "\$log_action = array(";

        foreach ( $action as $k => $v )

        {

            $str_action .= "'" . $k . "' => '" . addslashes($v) . "',";

        }

        $action = substr($str_action, 0, strlen($str_action)- 1) . ");";

        

        // Take the newlines and tabs (or spaces > 1) out of the action

        $action = preg_replace("/[[:space:]]{2,}/", '', $action);

        $action = str_replace("\t", '', $action);

        $action = str_replace("\n", '', $action);

        $action = preg_replace("#(\\\){1,}#", "\\", $action);

        

        return $action;

    }

	





?>







Paste the data from DragonLord's DKP into the big text area and press the button.<br>






<br>



<br>







<form method="post">



<textarea style="width: 700px; height: 400px;" name="data"></textarea>



<br>



<br>







<input type="submit" value="Import DKP Data">







</form>











</body>



</html>







<?php



    function gen_group_key($part1, $part2, $part3)

    {

        // Normalize data

        $part1 = htmlspecialchars(stripslashes($part1));

        $part2 = htmlspecialchars(stripslashes($part2));

        $part3 = htmlspecialchars(stripslashes($part3));

        

        // Get the first 10-11 digits of each md5 hash

        $part1 = substr(md5($part1), 0, 10);

        $part2 = substr(md5($part2), 0, 11);

        $part3 = substr(md5($part3), 0, 11);

        

        // Group the hashes together and create a new hash based on uniqid()

        $group_key = $part1 . $part2 . $part3;

        $group_key = md5(uniqid($group_key));

        

        return $group_key;

    }

